#include <DbgEng.h>

class CEventCallbacks : public IDebugEventCallbacks
{
private:
	long m_ref;
	ULONG numHits;
public:
	CEventCallbacks()
	{
		m_ref = 1;
		numHits = 0;
	}

	~CEventCallbacks()
	{
	}

	//IUnknown
	STDMETHOD(QueryInterface)(__in REFIID InterfaceId, __out PVOID* Interface);
	STDMETHOD_(ULONG, AddRef)();
	STDMETHOD_(ULONG, Release)();

	//IDebugEventCallbacks
	STDMETHOD(Breakpoint)(__in PDEBUG_BREAKPOINT bp);
	STDMETHOD(GetInterestMask)(__out PULONG Mask);
	STDMETHOD(Exception)(__in PEXCEPTION_RECORD64 Exception, __in ULONG FirstChance);
	STDMETHOD(CreateThread)(__in ULONG64 handle, __in ULONG64 DataOffset, __in ULONG64 StartOffset);

	/*
	STDMETHOD(ChangeDebuggeeState)(__in ULONG ulFlags, __in ULONG64 ulArgument);
	STDMETHOD(ChangeEngineState)(__in ULONG ulFlags, __in ULONG64 ulArgument);
	STDMETHOD(ChangeSymbolState)(__in ULONG ulFlags, __in ULONG64 ulArgument);

	
	
	STDMETHOD(ExitProcess)(__in ULONG ExitCode);
	STDMETHOD(ExitThread)(__in ULONG ExitCode);
	STDMETHOD(SessionStatus)(__in ULONG Status);
	STDMETHOD(SystemError)(__in ULONG Error, __in ULONG Level);
	STDMETHOD(UnloadModule)(__in_opt PCSTR ImageBaseName, __in ULONG64 BaseOffset);



	STDMETHOD (CreateProcess)
	(
		__in ULONG64 ImgfileHandle,
		__in ULONG64 Handle,
		__in ULONG64 BaseOffset,
		__in ULONG   ModuleSize,
		__in_opt PCSTR ModuleName,
		__in_opt PCSTR ImageName,
		__in ULONG   CheckSum,
		__in ULONG   TimeDateStamp,
		__in ULONG64 InitialThreadHandle,
		__in ULONG64 ThreadDataOffset,
		__in ULONG64 StartOffset
	);

	STDMETHOD (LoadModule)
	(
		__in ULONG64 ImageFileHandle,
		__in ULONG64 BaseOffset,
		__in ULONG   ModuleSize,
		__in_opt PCSTR ModuleName,
		__in_opt PCSTR ImageName,
		__in ULONG CheckSum,
		__in ULONG TimeDateStamp
	);*/



	//Helper functions
	STDMETHOD_(ULONG, GetNumHits)();
};