#ifndef MDL_H
#define MDL_H

#include <DbgEng.h>
#include "ModuleFunctions.h"
#include "MemoryFunctions.h"

class MDL
{
public:
	MDL();
	MDL(IDebugClient *pDebugClient, ULONG64 adr);
	~MDL();
	VOID updateAddr(IDebugClient *pDebugClient, ULONG64 adr);
	ULONG64 getProc(){return *procAddr;}
	BOOL isValid(){return valid;}
	BOOL getLinked(){return isLinked;}
	UINT getByteCount(){return byteCount;}
	UINT getByteOffset(){return byteOffset;}
	ULONG64 getAddr(){return *mdlAddr;}
private:
	BOOL ReadProcess(IDebugClient *pDebugClient);
	BOOL ReadBytes(IDebugClient *pDebugClient);
	BOOL checkNext(IDebugClient *pDebugClient);
	BOOL valid;
	BOOL isLinked;
	UINT byteCount;
	UINT byteOffset;
	PULONG64 mdlAddr;
	PULONG64 procAddr;
};

#endif;
