/*MemoryFunctions.h*/
/*Sets of functions to read (and write) memory*/
/*Written by Hans Kristian Brendmo*/

#include <DbgEng.h>

ULONG64 SignExtend(IDebugClient* pDebugClient, ULONG64 ptr);
HRESULT ReadVirtual(IDebugClient* pDebugClient, ULONG64 Offset, PVOID Buffer, ULONG BufferSize, PULONG BytesRead);
HRESULT ReadPage(IDebugClient* pDebugClient, ULONG pfnNo, PVOID Buffer);

HRESULT ReadVirtualR(IDebugClient* pDebugClient, ULONG64 Offset, PVOID Buffer, ULONG BufferSize, PULONG BytesRead);
HRESULT ReadVirtualC(IDebugClient* pDebugClient, ULONG64 Offset, PVOID left, PVOID right, ULONG BufferSize, PULONG BytesRead);

HRESULT SearchNonPaged(IDebugClient *pDebugClient, PVOID pattern, ULONG patSize, ULONG64 length, PULONG64 result );