/*node.h*/
/*Class to describe a node in an AVL tree*/
/*By Hans Kristian Brendmo*/

#ifndef NODE_H
#define NODE_H

#include <Windows.h>
#include "dbgeng.h"

class NODE
{

public:
	NODE(ULONG64 adr, IDebugClient *pDebugClient);
	~NODE();
	ULONG64 left();
	ULONG64 right();
	ULONG64 adr();
	UINT length();
	void setadr(ULONG64 adr, IDebugClient *pDebugClient);

private:	
	PVOID* nodeAdr;
	PVOID* leftAdr;
	PVOID* rightAdr;
	PVOID* lengthAdr;
};

#endif;