//PFNdata.h Class for storing PFNdat objects:

#ifndef PFNDATA_H
#define PFNDATA_H

#include <dbgeng.h>
#include "MemoryFunctions.h"
#include "process.h"

class PFNdata
{
public:

	PFNdata(IDebugClient *pDebugClient, ULONG pfnNo);
	~PFNdata();

	ULONG64 pfnToAddr (ULONG pfnNO);
	BOOL isValid() {return valid;}
	BOOL isDriverLocked();
	ULONG64 getAdr(){return *pfnAdr;}
	ULONG64 getProc(){return *procAdr;}
private:
	PULONG64 pfnAdr;
	PULONG64 pteAdr;
	//PROCESS *ownProc;
	PULONG64 procAdr;
	BOOL valid;

	BOOL readPte(IDebugClient *pDebugClient);
	ULONG64 readProcess(IDebugClient *pDebugClient);
	
};

#endif;