//1. Search for MDLs by searching for valid MDL pool headers
//2. Read MDL -> Output to file

#include <DbgEng.h>
#include "POOL.h"
#include "MDL.h"
#include "MemoryFunctions.h"

HRESULT FindValidMdls(IDebugClient *pDebugClient);
HRESULT SearchForMdlHeader(IDebugClient *pDebugClient, ULONG64 startAdr, ULONG64 length,  PULONG64 result);
HRESULT SearchForStart(IDebugClient *pDebugClient, PULONG64 result);
BOOL ValidHeader(IDebugClient *pDebugClient, ULONG64 headerAdr);
BOOL ValidMdl(IDebugClient *pDebugClient, ULONG64 mdlAdr);
UINT SearchBuffer(PVOID buf, UINT bufSize, PUINT positions);
