//#include <windows.h>
#include <dbgeng.h>
#include "MDL.h"
#include <stack>


HRESULT SetBreakpoints(IDebugClient* pDebugClient);
HRESULT StartLogging(IDebugClient* pDebugClient);
HRESULT ClearBreakpoints(IDebugClient* pDebugClient);

//Traverse AVL tree
HRESULT TraverseTree(IDebugClient* pDebugClient, PVOID *input);

//Output MDL data for Lock tracker:
HRESULT MdlData(IDebugClient* pDebugClient, ULONG64 adr, MDL *m);
//Traverse the active process list
//HRESULT TraverseProcesses(IDebugClient* pDebugClient, ULONG64 offset);
// Read PFN data:
//HRESULT ReadPFNData(IDebugClient* pDebugClient, PCSTR addr);

//Output error:
HRESULT OutputError(IDebugClient* pDebugClient,  PCSTR message, HRESULT err);

//Output PFN database:
HRESULT ReadPfnData(IDebugClient * pDebugClient, PCSTR num);
HRESULT ReadPfnDatabase(IDebugClient * pDebugClient);
HRESULT WriteVM(IDebugClient * pDebugClient);

//Read PoolHeader
HRESULT ReadPoolHeader(IDebugClient *pDebugClient, PCSTR arg);

//Write Memory:
HRESULT WriteMem(IDebugClient *pDebugClient, ULONG64 start, UINT length, PCSTR szFileName);

void TestWrite();