/*************************************
Generic class for implementing the RTL_BALANCED_NODE
datastructure for tree-datastructures. 
*************************************/
#ifndef BALNODE_H
#define BALNODE_H

#include <Windows.h>
#include "Helper.h"

class BALNODE
{
public:
	//Cons and destructors:
	BALNODE();
	BALNODE(ULONG64 left, ULONG64 right, ULONG64 parent);
	~BALNODE();
	//Helpers:
	VOID updateNode(PVOID nodeData);
	ULONG64 getLeft(){return leftAdr;}
	ULONG64 getRight(){return rightAdr;}
	ULONG64 getParent(){return parentAdr;}
private:
	ULONG64 leftAdr;
	ULONG64 rightAdr;
	ULONG64 parentAdr;
};

#endif;