/*************************************
Helper class for Doubly Linked Lists
by Hans Kristian Brendmo
*************************************/
#ifndef DLIST_H
#define DLIST_H

#include <Windows.h>
#include "Helper.h"

class DLIST
{
public:
	DLIST();
	DLIST(ULONG64 fL, ULONG64 bL);
	~DLIST();
	DLIST(ULONG64 *arr);
	ULONG64 next() {return fLink;}
	ULONG64 back() {return bLink;}
	UINT size(ULONG64 pageDir, HANDLE hFile1, HANDLE hFile2);  // Returns the number of elements in the list
	BOOL Traverse(ULONG64 pageDir, HANDLE hFile1, HANDLE hFile2, UINT numElements, ULONG64 *addressesv);
	VOID Update(ULONG64 *arr);
	VOID Update(ULONG64 fL, ULONG64 bL);
private:
	ULONG64 fLink;
	ULONG64 bLink;
};

#endif;