#include "Helper.h"

//Byte array operations:
ULONG64 ConvertToUlong64(BYTE *numberArray);
UINT ConvertToUint(BYTE *b);
ULONG64 ReadPointer(BYTE *numberArray, UINT offset);
UINT ReadUint(BYTE *b, UINT offset);
VOID DwordToByteArr(BYTE *byteArray, DWORD num, UINT offsetArray);
VOID Ulong64ToByteArr(BYTE *byteArray, ULONG64 num, UINT offsetArray);
VOID ReverseUlong64(BYTE *ByteArray);

//Math
ULONG64 IntegerPower(UINT exponent, ULONG base);

//String operations:
BOOL PrintUnicodeString(ULONG64 physAdr, ULONG64 data, HANDLE hOpen);
BOOL ShortenString(TCHAR *inString, TCHAR *outString, UINT length);
ULONG64 StringToUlong64(TCHAR *string, UINT stringLength);
ULONG NormalizeChar(TCHAR numberChar);
BOOL ValidAsciiChar(CHAR asciiChar);