#ifndef PEB_H
#define PEB_H

#define PEBSIZE 0x7a0

#include <Windows.h>

class PEB
{
public:
	PEB();
	PEB(ULONG64 startAdr);
	~PEB();
	BOOL ReadData(HANDLE hFile1, HANDLE hFile2, ULONG64 pageDir);
	BOOL ReadParamData(HANDLE hFile1, HANDLE hFile2, ULONG64 pageDir);
	BOOL isValid();
	ULONG64 getProcParam();
	VOID OutPutData(HANDLE hFile1, HANDLE hFile2, ULONG64 pageDir);
	//static const UINT PEBSIZE = 0x7a0;
	static const UINT PAROFF = 0x20;
	static const UINT PARAMSIZE = 0x410;
private:
	ULONG64 start;
	ULONG64 processParam;
	BOOL valid;
	BYTE rawData[PEBSIZE];
	BYTE paramData[PARAMSIZE];

	ULONG64 ReadProcessParam();
};

#endif