#include "PageEntry.h"


PageEntry::PageEntry()
{
	entry = 0;
}

PageEntry::PageEntry(ULONG64 address)
{
	entry = address;
}

PageEntry::~PageEntry()
{
}


BOOL PageEntry::isValid()
{
	BOOL valid = false;
	if(entry & 0x1)
	{
		valid = true;
	}
	return valid;
}
BOOL PageEntry::isLarge()
{
	BOOL largePage = false;
	if(entry & 0x100)
	{
		largePage = true;
	}
	return largePage;
}

ULONG64 PageEntry::physAddress()
{
	const ULONG64 mask = 0xFFFFFFF000;
	ULONG64 PFN = (entry & mask);
	return PFN;
}