/*
#ifndef POOL_H
#define POOL_H

#include <Windows.h>

class POOL

{

public:
	POOL::POOL(BYTE *buffer, ULONG64 addr);
	~POOL();
	UINT getPrevSize(){return prevSize;}
	UINT getPoolIndex(){return poolIndex;}
	UINT getBlockSize(){return blockSize;}
	ULONG64 getAdr() {return *poolAdr;}
	UINT getTag(){return tag;}
	BOOL getValid(){return valid;}
	
	VOID outputData();
private:
	//Ulong: (4 byte) (0x0)
	UINT prevSize;
	UINT poolIndex;
	UINT blockSize;
	UINT poolType;
	//Tag: (4 byte) (0x4)
	UINT tag;
	char *szTag; 
	//Process: (8 byte) (0x8)
	BOOL ReadBuffer(BYTE *buffer, ULONG64 start, UINT length, BYTE *outBuf);
	ULONG64 process;
	PULONG64 poolAdr;
	BOOL valid;
	BOOL isValid();
	BOOL readData(BYTE *buffer);
};

#endif;

*/